'use strict';
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Namer = void 0;
const path_1 = __importDefault(require("path"));
class Namer {
    constructor(path, name) {
        path = path || '';
        name = name || '';
        this.path = path;
        this.name = name[name.length - 1] === '.' ? name.substring(0, name.length - 1) : name;
    }
    pathCreator(type, ext) {
        ext = ext || 'txt';
        var cleanedExt = ext[0] === '.' ? ext.substring(1) : ext;
        return path_1.default.join(this.path, (this.name + "." + type + "." + cleanedExt));
    }
    getReceivedFile(ext) {
        return this.pathCreator("received", ext);
    }
    getApprovedFile(ext) {
        return this.pathCreator("approved", ext);
    }
}
exports.Namer = Namer;
module.exports = Namer;
