"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.verifyAll = exports.verifyAsJson = exports.verify = void 0;
const Printers_1 = require("../../Utilities/Printers");
const Options_1 = require("../../Core/Options");
const StringWriter = require("../../StringWriter");
const approvals = require("../../Approvals");
function verify(sut, options) {
    options = options || new Options_1.Options();
    const config = options.getConfig(approvals.getConfig());
    const scrubbed = options.scrub(`${sut}`);
    const writer = new StringWriter(config, scrubbed, options.forFile().getFileExtension());
    let namer = options.getNamer();
    approvals.verifyWithControl(namer, writer, null, config);
}
exports.verify = verify;
function verifyAsJson(data, options) {
    const text = (0, Printers_1.printJson)(data);
    options = options || new Options_1.Options();
    options = options.forFile().withFileExtention(".json");
    verify(text, options);
}
exports.verifyAsJson = verifyAsJson;
function verifyAll(header, list, formatter, options) {
    const text = (0, Printers_1.printArray)(header, list, formatter);
    verify(text, options);
}
exports.verifyAll = verifyAll;
