"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.printCombinations = exports.EMPTY = exports.printJson = exports.printArray = void 0;
function printArray(header, list, formatter) {
    function getDefaultFormatter() {
        let count = 0;
        return (t) => `[${count++}] => ${t}`;
    }
    formatter = formatter || getDefaultFormatter();
    let text = "";
    if (header) {
        text = header + "\n\n\n";
    }
    for (let t of list) {
        text += formatter(t) + "\n";
    }
    return text;
}
exports.printArray = printArray;
function printJson(data) {
    return JSON.stringify(data, null, "  ");
}
exports.printJson = printJson;
const EMPTY_ENTRY = {};
exports.EMPTY = [EMPTY_ENTRY];
function printCombinations(func, params1, params2, params3, params4, params5, params6, params7, params8, params9) {
    let text = "";
    for (let p1 of params1) {
        for (let p2 of params2) {
            for (let p3 of params3) {
                for (let p4 of params4) {
                    for (let p5 of params5) {
                        for (let p6 of params6) {
                            for (let p7 of params7) {
                                for (let p8 of params8) {
                                    for (let p9 of params9) {
                                        let output;
                                        try {
                                            output = func(p1, p2, p3, p4, p5, p6, p7, p8, p9);
                                        }
                                        catch (e) {
                                            output = `${e}`;
                                        }
                                        const parameters = [p1, p2, p3, p4, p5, p6, p7, p8, p9].filter(p => p !== EMPTY_ENTRY);
                                        text += `[${parameters}] => ${output}\n`;
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    }
    return text;
}
exports.printCombinations = printCombinations;
